<?php

require "guiFunctions.php";
require "database.php";

function displayJavascript()
{
?>

<script language="javascript">
function check()
{
  whiteScore = eval( document.addGame.whiteBackScore.value + '+' + document.addGame.whiteFrontScore.value);
  blueScore = eval( document.addGame.blueBackScore.value + '+' + document.addGame.blueFrontScore.value);

  if (((whiteScore != 10) && (blueScore != 10)) || (blueScore > 10) || (whiteScore > 10) || (whiteScore == blueScore))
  {
      alert('Please correct scores (one must add up to 10)');
  }
  else
  {
      document.addGame.submit();
  }

}
</script>

<?php
} // displayJavascript()

function encryptPassword($nonEncryptPassword)
{
    $length = strlen($nonEncryptPassword);
    $newPassword = "";
    for ($i = 0; $i < $length; $i++) {
        $tempChar = substr("$nonEncryptPassword", $i, 1);
        $temp = ord($tempChar);
        $temp = ($temp + 3)% 26 + 95;
        $tempChar = chr($temp);
        $newPassword = str_pad($newPassword, $i+1, $tempChar);
    }
    return $newPassword;
}

function checkPassword( $seasonId, $password )
{
	$encryptedPassword = encryptPassword($password);

	// get actual password
	$query = "SELECT password FROM foosball_league WHERE seasonId=$seasonId";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	$line = mysql_fetch_array( $result );
	$realPassword = $line["password"];

	if ( $encryptedPassword == $realPassword )
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

function getSeasonPlayers( $seasonId )
{
	$query = "SELECT pid FROM foosball_leaguePlayer WHERE seasonId=$seasonId";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	$returnArray = array();
	while ($line = mysql_fetch_array( $result ))
	{
		$returnArray[] = $line['pid'];
	}
	return $returnArray;
}

function displayGamePlayersPullDown( $seasonId, $fieldName )
{
	$query = "SELECT firstName, lastName, foosball_player.pid FROM foosball_player, foosball_leaguePlayer WHERE foosball_player.pid=foosball_leaguePlayer.pid AND foosball_leaguePlayer.seasonId=$seasonId ORDER BY foosball_player.firstName";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;

	print "<select name='$fieldName'>";
	while ($line = mysql_fetch_array( $result ) )
	{
		print "<option value='".$line['pid']."'>".$line['firstName']." ".$line['lastName'];
	}
	print "</select>";
}

function displayGameScorePullDown( $fieldName )
{
	print "<select name='$fieldName'>";
	for( $i = 0; $i < 11; $i++ )
	{
		print "<option value='$i'>$i";
	}
	print "</select>";
}

function displaySeasonPlayersPullDown( $seasonId )
{
	$query = "SELECT firstName, lastName, foosball_player.pid FROM foosball_player, foosball_leaguePlayer WHERE foosball_player.pid=foosball_leaguePlayer.pid AND foosball_leaguePlayer.seasonId=$seasonId ORDER BY foosball_player.firstName";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;

	if ( mysql_num_rows($result) > 0 )
	{
		print "<form name='removePlayer' method='POST' action='season.php'>";
		print "<input type='hidden' name='page' value='removePlayer'>";
		print "<input type='hidden' name='seasonId' value='$seasonId'>";
		print "<select name='player'>";
		while ($line = mysql_fetch_array( $result ) )
		{
			print "<option value='".$line['pid']."'>".$line['firstName']." ".$line['lastName'];
		}
		print "</select>";
		print "<input type='submit' value='Remove Player'>";
		print "</form>";
	}
}

function displaySeasonNonPlayersPullDown( $seasonId )
{
	$currentPlayers = getSeasonPlayers( $seasonId );
	$condition = '';
	if ( count($currentPlayers) > 0 )
	{
		$condition = "WHERE pid NOT IN (".join(",",$currentPlayers).")";
	}
	$query = "SELECT firstName, lastName, pid FROM foosball_player $condition ORDER BY firstName";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;

	if ( mysql_num_rows($result) > 0 )
	{
		print "<form name='addPlayer' method='POST' action='season.php'>";
		print "<input type='hidden' name='page' value='addPlayer'>";
		print "<input type='hidden' name='seasonId' value='$seasonId'>";
		print "<select name='player'>";
		while ($line = mysql_fetch_array( $result ) )
		{
			print "<option value='".$line['pid']."'>".$line['firstName']." ".$line['lastName'];
		}
		print "</select>";
		print "<input type='submit' value='Add Player'>";
		print "</form>";
	}
}

function display( $seasonId, $admin )
{
	displayJavascript();
	$query = "SELECT startDate, league, description FROM foosball_league WHERE seasonId=$seasonId";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	$line = mysql_fetch_array( $result );
	
	$blueSideColour = "Blue";
	$whiteSideColour = "White";
	getTableColours($seasonId, $blueSideColour, $whiteSideColour);
	
	top_navbar($seasonId);

	print "<center>";
	print "<table bgcolor='#CCCCCC' cellspacing='5' cellpadding='5'>"; //begin table1
	print "<tr><td align='center'>";
	print "<table>"; //begin table2
	print "<tr><td align='center'>";

	print "<b>".$line['league']."</b><br>";
	print "<i>".$line['description']."</i><br>&nbsp;";	

	print "</tr></td>";
	print "<tr><td align='center'>";

	print "<table border='1' cellpadding='3'><tr><td align='center'>"; //begin table3
	print "<b>Current League Players</b><br>";
	// get league players
	$query = "SELECT firstName, lastName FROM foosball_player, foosball_leaguePlayer WHERE foosball_player.pid=foosball_leaguePlayer.pid AND foosball_leaguePlayer.seasonId=$seasonId ORDER BY firstName";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;

	if ( mysql_num_rows($result) == 0 )
	{
		print "<i>No players involved in league.</i><br>";
	}
	else
	{
		while ($line = mysql_fetch_array( $result ) )
		{
			print $line['firstName']." ".$line['lastName']."<br>";
		}
	}
	print "</td></tr></table><br>&nbsp;</td></tr>"; //end table3
	print "</td></tr>";
	print "<tr><td align='center'>";

	if ( $admin > 0 )
	{
		// add players
		displaySeasonNonPlayersPullDown( $seasonId );
		// remove players
		displaySeasonPlayersPullDown( $seasonId );
	}

	print "</td></tr>";

	print "</table"; //end table2
	print "<table>"; //begin table4
	print "</td></tr>";
	print "<tr><td align='center'>";

	// add a game
	$currentPlayers = getSeasonPlayers( $seasonId );

	print "<b>Add a Game</b><br>";
	if ( count( $currentPlayers ) > 0 )
	{
		?>
		<form name="addGame" method="POST" action="summary.php">
		<input type='hidden' name='page' value='addGame'>
		<input type='hidden' name='seasonId' value='<?php print $seasonId?>'>
		<table>
			<tr>
				<td width="70">Position</td>
				<td align="center"><?php print $whiteSideColour;?> Players</td>
				<td>Goals</td>
				<td align="center"><?php print $blueSideColour;?> Players</td>
				<td>Goals</td>
			</tr>
			<tr>
				<td><b>Back:</b></td>
				<td><?php displayGamePlayersPullDown( $seasonId, 'whiteBackPlayer');?></td>
				<td><?php displayGameScorePullDown( 'whiteBackScore');?></td>
				<td><?php displayGamePlayersPullDown( $seasonId, 'blueBackPlayer');?></td>
				<td><?php displayGameScorePullDown( 'blueBackScore');?></td>
			</tr>
			<tr>
				<td><b>Front:</b></td>
				<td><?php displayGamePlayersPullDown( $seasonId, 'whiteFrontPlayer');?></td>
				<td><?php displayGameScorePullDown( 'whiteFrontScore');?></td>
				<td><?php displayGamePlayersPullDown( $seasonId, 'blueFrontPlayer');?></td>
				<td><?php displayGameScorePullDown( 'blueFrontScore');?></td>
			</tr>
			<tr>
				<td><b>Comments:</b></td>
				<td colspan="4" align="center">
				<textarea name="comments"></textarea>
				</td>
			</tr>
			<tr>
				<td colspan="5" align="center">
				<a href="javascript:check()">Add Game</a>
				<input type="hidden" name="Submit" value="Add Game">
				</td>
			</tr>
		</table>
		</form>
		<?php
	}
	else
	{
		print "<i>No Players involved in league.</i>";
	}
	print "</td></tr>";
	print "</table>"; // end table4
	print "</td></tr>";
	print "</table>"; // end table1
	print "</center><p>";

}

//*******************************************************************************
//**                          ACTUAL PAGE START                                **
//*******************************************************************************

start_page("Season Details");
$page = $HTTP_POST_VARS["page"];

// If we're coming from create a season
if ( $page == "createSeason" )
{
	// add the season
	$description = $HTTP_POST_VARS["description"];
	$league = $HTTP_POST_VARS["league"];
	$whiteColour = $HTTP_POST_VARS["whiteColour"];
	$blueColour = $HTTP_POST_VARS["blueColour"];
	$password = $HTTP_POST_VARS["password"];
	$password = encryptPassword( $password );

	$query = "INSERT INTO foosball_league VALUES ( '', NOW(), '$league', '$description', '$password', '$blueColour', '$whiteColour')";

	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	$result = mysql_query("SELECT LAST_INSERT_ID()")
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	$seasonId = mysql_result($result,0);

	// display the new season
	display( $seasonId, 2 );
}
elseif ( $page == "removePlayer" )
{
	$seasonId = $HTTP_POST_VARS["seasonId"];
	$player = $HTTP_POST_VARS["player"];
	$query = "INSERT INTO foosball_league VALUES ( '', NOW(), '$league', '$description')";
	$query = "DELETE FROM foosball_leaguePlayer WHERE pid=$player AND seasonId=$seasonId";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	display( $seasonId, 2 );
}
elseif ( $page == "addPlayer" )
{
	$seasonId = $HTTP_POST_VARS["seasonId"];
	$player = $HTTP_POST_VARS["player"];
	$query = "INSERT INTO foosball_leaguePlayer VALUES ( $seasonId, $player )";
	$result = mysql_query($query)
		or die("Query failed:[" . mysql_errno() . "] " . mysql_error()) .
			__LINE__ . " in file " . __FILE__;
	display( $seasonId, 2 );
}
elseif ( $page == "home" )
{
	$seasonId = $HTTP_POST_VARS["seasonId"];
	display( $seasonId, 0 );
}
elseif ( $page == "admin" )
{
	$seasonId = $HTTP_POST_VARS["seasonId"];
	$password = $HTTP_POST_VARS["adminPassword"];
	if ( checkPassword( $seasonId, $password ) )
	{
		display( $seasonId, 1 );
	}
	else
	{
		print "<center><b><font color='red'>Incorrect Season Administrator Password.</font></b></center>";
	}
}
else
{
	$seasonId = $_GET['league'];
	display( $seasonId, 0 );
}
?>


<?php
	end_page($seasonId);
?>
